"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  assert: () => assert,
  validate: () => validate,
  validationAdapter: () => validationAdapter,
  wrap: () => wrap
});
module.exports = __toCommonJS(src_exports);
var import_core = require("@typeschema/core");

// src/validation.ts
var validationAdapter = async (schema) => {
  return async (data) => {
    try {
      return {
        data: await schema(data),
        success: true
      };
    } catch (error) {
      if (error instanceof Error) {
        return {
          issues: [{ message: error.message }],
          success: false
        };
      }
      throw error;
    }
  };
};

// src/index.ts
var validate = (0, import_core.createValidate)(validationAdapter);
var assert = (0, import_core.createAssert)(validate);
var wrap = (0, import_core.createWrap)(assert, validate);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  assert,
  validate,
  validationAdapter,
  wrap
});
